﻿@using Jb.Framework.Common.Forms
@model JbForm

@helper WriteSection(JbSection jbSection)
    {
        <div class="JbSection">
            <h3 class="jb-section-title">@jbSection.Title</h3>
            @foreach (var element in jbSection.Elements)
            {
                if (element is JbSection)
                {
                    <text>
                        @WriteSection(element as JbSection)
                    </text>
                }
                else if (!(element is JbHidden || element is JbParagraph))
                {
                    @Html.EditorFor(m => element, "JbElement")
                }
            }
        </div>
}

<link href="~/Content/Student/Program/Form.css" rel="stylesheet" />

<div class="JbForm static">

    @Html.Hidden("ModelType", Model.GetType())
    @Html.HiddenFor(m => m.Id)
    @Html.HiddenFor(m => m.CurrentMode)
    @Html.HiddenFor(m => m.RefEntityId)
    @Html.HiddenFor(m => m.RefEntityName)

    @if (Model.CurrentMode == AccessMode.ReadOnly)
    {
        @Html.HiddenFor(m => m.JsonElements)
        for (var i = 0; i < Model.Elements.Count(); i++)
        {
            if (Model.Elements[i] is JbSection)
            {
                <text>
                    @WriteSection(Model.Elements[i] as JbSection)
                </text>
            }
            else if (!(Model.Elements[i] is JbHidden))
            {
                @Html.EditorFor(m => m.Elements[i], "JbElement")
                <br />
            }
        }
    }
    else
    {
        if (Model.CurrentMode == AccessMode.Design)
        {
            <a class="formBuilderCaller dropdown-toggle btn btn-info" data-toggle="dropdown"
               data-jbformid="@Model.Id"
               data-refentityname="@Model.RefEntityName"
               data-refentityid="@Model.RefEntityId" href="#">
                @(Model.Elements.Any() ? "Edit Form" : "Create New Form")
            </a>
        }

        ViewBag.VisibleMode = Model.VisibleMode;

        for (var i = 0; i < Model.Elements.Count(); i++)
        {
            @Html.EditorFor(m => m.Elements[i])
        }
    }
</div>

@if (Model.CurrentMode != AccessMode.ReadOnly)
{
    <text>

        <script src="~/Scripts/Libraries/form2js.js"></script>
        <script src="~/Scripts/Libraries/jQuery/jquery.mask.min.js"></script>
        @Scripts.Render("~/bundles/jqueryValidateUnobtrusive")
    </text>

    <script type="text/javascript">

        $(".formBuilderCaller").unbind().bind('click', function (e) {
            e.preventDefault();
            var jbFormId = $(this).attr("data-JbFormId");
            var refEntityName = $(this).attr("data-RefEntityName");
            var refEntityId = $(this).attr("data-RefEntityId");
            var url = '@Url.Action("Edit", "FormBuilder")' + '?id=' + jbFormId + '&entityName=' + refEntityName + '&entityId=' + refEntityId;
            CallSecondPopUpData(url, '', 'PopUpJbFormBuilder');
        });

        $(".Custom-label").each(function () {
            $(this).html($(this).data("value"));
        });

        try {
            $(".CF-datepicker").datepicker();
        }
        catch (ex) { }

        $("input.JbPhone.US").mask("999-999-9999", { placeholder: "e.g. 555-666-7777" });
        $("input.JbPhone.INTERNATIONAL").mask("000000000000000", { placeholder: "e.g. 123456789" });

        $('.dob').mask('99/99/9999', { placeholder: "MM/DD/YYYY" });

        //condition logic
        $('document').ready(function () {
            $("[data-conditional='True']").each(function () {
                var elementConditional = $(this);
                var relatedElementId = $(this).data('relatedelementid');
                var relatedElementValue = $(this).data('relatedelementvalue');
                var relatedElement = $("[data-clientid=" + relatedElementId + "]");

                if (relatedElement) {

                    if (relatedElement.val() == relatedElementValue || relatedElement.length < 1) {
                         elementConditional.parent().show();
                          if (elementConditional.val().trim() == "####") {
                                elementConditional.val("")
                          }
                        }
                        else {           
                         elementConditional.parent().hide();
                         if (elementConditional.val() == "" || !(elementConditional.val())) {
                                elementConditional.val("####")
                         }
                    }

                    relatedElement.on('change', function () { 

                        if (this.value == relatedElementValue) {
                            elementConditional.parent().show();
                            if (elementConditional.val().trim() == "####") {
                               elementConditional.val("")
                            }

                            $("[data-conditional='True']").each(function (index, value) {
                                var elementConditional2 = $(this);

                                var relatedElementId2 = $(this).attr('data-relatedelementid');

                                if (elementConditional.data('clientid') == relatedElementId2) {
                                    elementConditional2.parent().show();
                                }
                            });
                        }
                        else {           
                            elementConditional.parent().hide();

                            if (elementConditional.val() == "" || !(elementConditional.val())) {
                                elementConditional.val("####")
                            }

                            $("[data-conditional='True']").each(function (index, value) {
                                var elementConditional2 = $(this);

                                var relatedElementId2 = $(this).attr('data-relatedelementid');

                                if (elementConditional.data('clientid') == relatedElementId2){
                                    elementConditional2.parent().hide();
                                }
                            });
                        }
                    })  

                }
            })
        })

        ///// Address State Fill by select Country
        $("[data-states]").hide();
        $("[data-txtstate]").show();

        function FillStates(elm) {
            var country = elm.value;
            $.ajax({
                url: '/Registrant/FillState',
                type: "GET",
                dataType: "JSON",
                data: { country: country },
                success: function (states) {
                    var addressSection = $(elm).closest(".JbAddress");
                    addressSection.find("[data-states]").html(""); // clear before appending new list
                    addressSection.find("[data-states]").append("<option value></option>");
                    if (Object.keys(states).length == 0) {
                        addressSection.find("[data-states]").hide();
                        addressSection.find("[data-txtstate]").show();
                    } else {
                        addressSection.find("[data-states]").show();
                        addressSection.find("[data-txtstate]").hide();
                        $.each(states, function (i, state) {

                            addressSection.find("[data-states]").append(
                                $('<option></option>').val(state.Value).html(state.Text));

                        });

                    }

                }
            });
        }
    </script>
}

